unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RBCalendar, ExtCtrls, StdCtrls, Spin, ComCtrls;

type
  TMainForm = class(TForm)
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    Calendar: TRBCalendar;
    CommandsPanel: TPanel;
    NavGroupBox: TGroupBox;
    GotoTodayButton: TButton;
    GotoPrevButton: TButton;
    GotoNextButton: TButton;
    ShowNavButtonsCheckBox: TCheckBox;
    AllowNavListCheckBox: TCheckBox;
    SelectionGroupBox: TGroupBox;
    SelectionKindRadioGroup: TRadioGroup;
    SideWeekSelectCheckBox: TCheckBox;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    TitlesColorButton: TButton;
    CaptionColorButton: TButton;
    FontButton: TButton;
    ColorButton: TButton;
    DayWidthSpinEdit: TSpinEdit;
    Label4: TLabel;
    DayHeightSpinEdit: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    CaptionHeightSpinEdit: TSpinEdit;
    ShowTodayCheckBox: TCheckBox;
    ShowLinesCheckBox: TCheckBox;
    ShowDividersCheckBox: TCheckBox;
    WidthSpinEdit: TSpinEdit;
    HeightSpinEdit: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    RichEdit1: TRichEdit;
    ShowPrevMonthCheckBox: TCheckBox;
    ShowNextMonthCheckBox: TCheckBox;
    FlatLookCheckBox: TCheckBox;
    MultiSelectCheckBox: TCheckBox;
    DayAlignmentRadioGroup: TRadioGroup;
    MarkDaysCheckBox: TCheckBox;
    procedure FontButtonClick(Sender: TObject);
    procedure WidthSpinEditChange(Sender: TObject);
    procedure HeightSpinEditChange(Sender: TObject);
    procedure ColorButtonClick(Sender: TObject);
    procedure CaptionColorButtonClick(Sender: TObject);
    procedure DayWidthSpinEditChange(Sender: TObject);
    procedure DayHeightSpinEditChange(Sender: TObject);
    procedure TitlesColorButtonClick(Sender: TObject);
    procedure ShowTodayCheckBoxClick(Sender: TObject);
    procedure GotoTodayButtonClick(Sender: TObject);
    procedure GotoPrevButtonClick(Sender: TObject);
    procedure GotoNextButtonClick(Sender: TObject);
    procedure ShowNavButtonsCheckBoxClick(Sender: TObject);
    procedure AllowNavListCheckBoxClick(Sender: TObject);
    procedure SideWeekSelectCheckBoxClick(Sender: TObject);
    procedure SelectionKindRadioGroupClick(Sender: TObject);
    procedure CaptionHeightSpinEditChange(Sender: TObject);
    procedure ShowLinesCheckBoxClick(Sender: TObject);
    procedure ShowDividersCheckBoxClick(Sender: TObject);
    procedure ShowPrevMonthCheckBoxClick(Sender: TObject);
    procedure ShowNextMonthCheckBoxClick(Sender: TObject);
    procedure FlatLookCheckBoxClick(Sender: TObject);
    procedure MultiSelectCheckBoxClick(Sender: TObject);
    procedure DayAlignmentRadioGroupClick(Sender: TObject);
    procedure CalendarMark(Sender: TObject; Day: TDate; var Mark: Boolean);
    procedure MarkDaysCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FontButtonClick(Sender: TObject);
begin
  if FontDialog.Execute then Calendar.Font := FontDialog.Font;
end;

procedure TMainForm.WidthSpinEditChange(Sender: TObject);
begin
  Calendar.MonthsInWidth := WidthSpinEdit.Value;
end;

procedure TMainForm.HeightSpinEditChange(Sender: TObject);
begin
  Calendar.MonthsInHeight := HeightSpinEdit.Value;
end;

procedure TMainForm.ColorButtonClick(Sender: TObject);
begin
  if ColorDialog.Execute then Calendar.Color := ColorDialog.Color;
end;

procedure TMainForm.CaptionColorButtonClick(Sender: TObject);
begin
  if ColorDialog.Execute then Calendar.CaptionsColor  := ColorDialog.Color;
end;

procedure TMainForm.DayWidthSpinEditChange(Sender: TObject);
begin
  Calendar.DayWidth := DayWidthSpinEdit.Value;
end;

procedure TMainForm.DayHeightSpinEditChange(Sender: TObject);
begin
  Calendar.DayHeight := DayHeightSpinEdit.Value;
end;

procedure TMainForm.TitlesColorButtonClick(Sender: TObject);
begin
  if ColorDialog.Execute then Calendar.TitlesColor := ColorDialog.Color;
end;

procedure TMainForm.ShowTodayCheckBoxClick(Sender: TObject);
begin
  Calendar.ShowToday := ShowTodayCheckBox.Checked;
end;

procedure TMainForm.GotoTodayButtonClick(Sender: TObject);
begin
  Calendar.GotoToday;
end;

procedure TMainForm.GotoPrevButtonClick(Sender: TObject);
begin
  Calendar.GotoPrevMonth;
end;

procedure TMainForm.GotoNextButtonClick(Sender: TObject);
begin
  Calendar.GotoNextMonth;
end;

procedure TMainForm.ShowNavButtonsCheckBoxClick(Sender: TObject);
begin
  Calendar.PrevMonthButton := ShowNavButtonsCheckBox.Checked;
  Calendar.NextMonthButton := ShowNavButtonsCheckBox.Checked;
end;

procedure TMainForm.AllowNavListCheckBoxClick(Sender: TObject);
begin
  Calendar.EnableCaptionPopup := AllowNavListCheckBox.Checked;
end;

procedure TMainForm.SideWeekSelectCheckBoxClick(Sender: TObject);
begin
  Calendar.SideWeekSelect := SideWeekSelectCheckBox.Checked;
end;

procedure TMainForm.SelectionKindRadioGroupClick(Sender: TObject);
begin
  Calendar.SelectionKind := TRBCSelectionKind(SelectionKindRadioGroup.ItemIndex);
end;

procedure TMainForm.CaptionHeightSpinEditChange(Sender: TObject);
begin
  Calendar.CaptionHeight := CaptionHeightSpinEdit.Value;
end;

procedure TMainForm.ShowLinesCheckBoxClick(Sender: TObject);
begin
  Calendar.ShowLines := ShowLinesCheckBox.Checked;
end;

procedure TMainForm.ShowDividersCheckBoxClick(Sender: TObject);
begin
  Calendar.ShowDividers := ShowDividersCheckBox.Checked;
end;

procedure TMainForm.ShowPrevMonthCheckBoxClick(Sender: TObject);
begin
  Calendar.ShowPrevMonth := ShowPrevMonthCheckBox.Checked;
end;

procedure TMainForm.ShowNextMonthCheckBoxClick(Sender: TObject);
begin
  Calendar.ShowNextMonth := ShowNextMonthCheckBox.Checked;
end;

procedure TMainForm.FlatLookCheckBoxClick(Sender: TObject);
begin
  Calendar.FlatLook := FlatLookCheckBox.Checked;
end;

procedure TMainForm.MultiSelectCheckBoxClick(Sender: TObject);
begin
  Calendar.MultiSelect := MultiSelectCheckBox.Checked;
end;

procedure TMainForm.DayAlignmentRadioGroupClick(Sender: TObject);
begin
  Calendar.DayAlignment := TAlignment ( DayAlignmentRadioGroup.ItemIndex );
end;

procedure TMainForm.CalendarMark(Sender: TObject; Day: TDate;
  var Mark: Boolean);
begin
  if (Day = Date+1) or ( day = Date+2 ) or ( day= Date+5) then
    Mark := True;
end;

procedure TMainForm.MarkDaysCheckBoxClick(Sender: TObject);
begin
  if MarkDaysCheckBox.Checked then Calendar.OnMark := CalendarMark
  else Calendar.OnMark := nil;
end;

end.

