// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RBTreeView.pas' rev: 4.00

#ifndef RBTreeViewHPP
#define RBTreeViewHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Menus.hpp>	// Pascal unit
#include <ImgList.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rbtreeview
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TRBTVScrollBar;
class DELPHICLASS TCustomRBTreeView;
class DELPHICLASS TRBTVEdit;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBTVEdit : public Stdctrls::TCustomEdit 
{
	typedef Stdctrls::TCustomEdit inherited;
	
private:
	TCustomRBTreeView* __fastcall GetTreeView(void);
	HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Message);
	HIDESBASE void __fastcall Changed(System::TObject* Sender);
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	__property TCustomRBTreeView* TreeView = {read=GetTreeView};
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyPress(char &Key);
	
public:
	__fastcall virtual TRBTVEdit(Classes::TComponent* AOwner);
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRBTVEdit(HWND ParentWindow) : Stdctrls::TCustomEdit(
		ParentWindow) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TWinControl.Destroy */ inline __fastcall virtual ~TRBTVEdit(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TRBTreeNode;
class DELPHICLASS TRBTreeNodes;
#pragma option push -b-
enum TRBTNAddMode { taAddFirst, taAdd, taInsert };
#pragma option pop

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBTreeNodes : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TRBTreeNode* FirstRootNode;
	TRBTreeNode* LastRootNode;
	int FCount;
	TCustomRBTreeView* FOwner;
	int FUpdateCount;
	void __fastcall AddedNode(TRBTreeNode* Value);
	HWND __fastcall GetHandle(void);
	TRBTreeNode* __fastcall GetNodeFromIndex(int Index);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
protected:
	TRBTreeNode* __fastcall InternalAddObject(TRBTreeNode* Node, const AnsiString S, void * Ptr, TRBTNAddMode 
		AddMode);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	void __fastcall SetItem(int Index, TRBTreeNode* Value);
	void __fastcall SetUpdateState(bool Updating);
	
public:
	__fastcall TRBTreeNodes(TCustomRBTreeView* AOwner);
	__fastcall virtual ~TRBTreeNodes(void);
	TRBTreeNode* __fastcall AddChildFirst(TRBTreeNode* Node, const AnsiString S);
	TRBTreeNode* __fastcall AddChild(TRBTreeNode* Node, const AnsiString S);
	TRBTreeNode* __fastcall AddChildObjectFirst(TRBTreeNode* Node, const AnsiString S, void * Ptr);
	TRBTreeNode* __fastcall AddChildObject(TRBTreeNode* Node, const AnsiString S, void * Ptr);
	TRBTreeNode* __fastcall AddFirst(TRBTreeNode* Node, const AnsiString S);
	TRBTreeNode* __fastcall Add(TRBTreeNode* Node, const AnsiString S);
	TRBTreeNode* __fastcall AddObjectFirst(TRBTreeNode* Node, const AnsiString S, void * Ptr);
	TRBTreeNode* __fastcall AddObject(TRBTreeNode* Node, const AnsiString S, void * Ptr);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall BeginUpdate(void);
	void __fastcall Clear(void);
	void __fastcall Delete(TRBTreeNode* Node);
	void __fastcall EndUpdate(void);
	TRBTreeNode* __fastcall GetFirstNode(void);
	TRBTreeNode* __fastcall Insert(TRBTreeNode* Node, const AnsiString S);
	TRBTreeNode* __fastcall InsertObject(TRBTreeNode* Node, const AnsiString S, void * Ptr);
	__property int Count = {read=FCount, nodefault};
	__property HWND Handle = {read=GetHandle, nodefault};
	__property TRBTreeNode* Item[int Index] = {read=GetNodeFromIndex/*, default*/};
	__property TCustomRBTreeView* Owner = {read=FOwner};
};

#pragma pack(pop)

#pragma option push -b-
enum TRBTNNodeState { nsCut, nsDropHilited, nsFocused, nsSelected, nsExpanded, nsEdited, nsHiddenSelected 
	};
#pragma option pop

typedef Set<TRBTNNodeState, nsCut, nsHiddenSelected>  TRBTNNodeStates;

struct TRBNodeInfo;
typedef TRBNodeInfo *PRBNodeInfo;

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBTreeNode : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TRBTreeNodes* FOwner;
	TRBTNNodeStates FState;
	TRBTreeNode* FParent;
	int FLevel;
	TRBTreeNode* FPrevSibling;
	TRBTreeNode* FNextSibling;
	TRBTreeNode* FFirstChild;
	TRBTreeNode* FLastChild;
	Windows::TRect FDisplayRect;
	Graphics::TColor FColor;
	bool FUseTreeColor;
	AnsiString FText;
	void *FData;
	AnsiString FStringData;
	int FIntData;
	int FItemId;
	bool FHasChildren;
	int FImageIndex;
	bool FDeleting;
	bool FInTree;
	int XOffset;
	int SubTreeLeft;
	int SubTreeRight;
	void __fastcall CalcSubTreePos(void);
	void __fastcall CalcDisplayRect(int Pos);
	void __fastcall InternalDraw(void);
	void __fastcall InternalDrawButton(void);
	void __fastcall InternalDrawImage(void);
	void __fastcall InternalDrawLines(void);
	bool __fastcall DoCanExpand(bool Expand);
	void __fastcall DoExpand(bool Expand);
	void __fastcall ExpandNode(bool Expand, bool Recurse);
	int __fastcall GetAbsoluteIndex(void);
	bool __fastcall GetExpanded(void);
	bool __fastcall GetIsVisible(void);
	bool __fastcall GetFocused(void);
	int __fastcall GetIndex(void);
	TRBTreeNode* __fastcall GetItem(int Index);
	bool __fastcall GetSelected(void);
	int __fastcall GetCount(void);
	TCustomRBTreeView* __fastcall GetTreeView(void);
	bool __fastcall IsEqual(TRBTreeNode* Node);
	void __fastcall ReadData(Classes::TStream* Stream, PRBNodeInfo Info);
	void __fastcall SetHasChildren(bool Value);
	void __fastcall SetData(void * Value);
	void __fastcall SetItem(int Index, TRBTreeNode* Value);
	void __fastcall SetExpanded(bool Value);
	void __fastcall SetFocused(bool Value);
	void __fastcall SetImageIndex(int Value);
	void __fastcall SetSelected(bool Value);
	void __fastcall SetText(const AnsiString S);
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetUseTreeColor(bool Value);
	void __fastcall WriteData(Classes::TStream* Stream, PRBNodeInfo Info);
	
public:
	__fastcall TRBTreeNode(TRBTreeNodes* AOwner);
	__fastcall virtual ~TRBTreeNode(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Collapse(bool Recurse);
	void __fastcall Delete(void);
	void __fastcall DeleteChildren(void);
	Windows::TRect __fastcall DisplayRect(bool TextOnly);
	Windows::TRect __fastcall ButtonRect(void);
	virtual void __fastcall Draw(void);
	bool __fastcall EditText(void);
	void __fastcall EndEdit(bool Cancel);
	void __fastcall Expand(bool Recurse);
	TRBTreeNode* __fastcall GetFirstChild(void);
	TRBTreeNode* __fastcall GetLastChild(void);
	HWND __fastcall GetHandle(void);
	TRBTreeNode* __fastcall GetNext(void);
	TRBTreeNode* __fastcall GetNextChild(TRBTreeNode* Value);
	TRBTreeNode* __fastcall GetNextSibling(void);
	TRBTreeNode* __fastcall GetNextVisible(void);
	TRBTreeNode* __fastcall GetPrev(void);
	TRBTreeNode* __fastcall GetPrevChild(TRBTreeNode* Value);
	TRBTreeNode* __fastcall GetPrevSibling(void);
	TRBTreeNode* __fastcall GetPrevVisible(void);
	bool __fastcall HasAsParent(TRBTreeNode* Value);
	int __fastcall IndexOf(TRBTreeNode* Value);
	void __fastcall MakeVisible(void);
	__property TRBTNNodeStates State = {read=FState, nodefault};
	__property int AbsoluteIndex = {read=GetAbsoluteIndex, nodefault};
	__property int Count = {read=GetCount, nodefault};
	__property void * Data = {read=FData, write=SetData};
	__property AnsiString StringData = {read=FStringData, write=FStringData};
	__property int IntData = {read=FIntData, write=FIntData, nodefault};
	__property bool Deleting = {read=FDeleting, nodefault};
	__property bool Focused = {read=GetFocused, write=SetFocused, nodefault};
	__property bool Selected = {read=GetSelected, write=SetSelected, nodefault};
	__property bool Expanded = {read=GetExpanded, write=SetExpanded, nodefault};
	__property HWND Handle = {read=GetHandle, nodefault};
	__property bool HasChildren = {read=FHasChildren, write=SetHasChildren, nodefault};
	__property int ImageIndex = {read=FImageIndex, write=SetImageIndex, nodefault};
	__property int Index = {read=GetIndex, nodefault};
	__property bool IsVisible = {read=GetIsVisible, nodefault};
	__property TRBTreeNode* Item[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__property int ItemId = {read=FItemId, nodefault};
	__property int Level = {read=FLevel, nodefault};
	__property TRBTreeNodes* Owner = {read=FOwner};
	__property TRBTreeNode* Parent = {read=FParent};
	__property AnsiString Text = {read=FText, write=SetText};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=65535};
	__property bool UseTreeColor = {read=FUseTreeColor, write=SetUseTreeColor, default=1};
	__property TCustomRBTreeView* TreeView = {read=GetTreeView};
};

#pragma pack(pop)

#pragma option push -b-
enum TRBTVNodeImageSide { nisLeft, nisRight };
#pragma option pop

#pragma option push -b-
enum TRBTVNodeStyle { nsSimple, nsShadowed };
#pragma option pop

typedef void __fastcall (__closure *TRBTVDrawNodeEvent)(System::TObject* Sender, TRBTreeNode* node, 
	const Windows::TRect &NodeRect);

typedef void __fastcall (__closure *TRBTVEditingEvent)(System::TObject* Sender, TRBTreeNode* Node, bool 
	&AllowEdit);

typedef void __fastcall (__closure *TRBTVEditedEvent)(System::TObject* Sender, TRBTreeNode* Node, AnsiString 
	&S);

typedef void __fastcall (__closure *TRBTVNodeNotifyEvent)(System::TObject* Sender, TRBTreeNode* Node
	);

typedef void __fastcall (__closure *TRBTVExpandingEvent)(System::TObject* Sender, TRBTreeNode* Node, 
	bool &AllowExpansion);

typedef void __fastcall (__closure *TRBTVCollapsingEvent)(System::TObject* Sender, TRBTreeNode* Node
	, bool &AllowCollapse);

typedef void __fastcall (__closure *TRBTVChangingEvent)(System::TObject* Sender, TRBTreeNode* Node, 
	bool &AllowChange);

#pragma option push -b-
enum TRBTVHitTest { htAbove, htBelow, htNowhere, htOnItem, htOnButton, htOnIcon, htOnIndent, htOnLabel, 
	htOnRight, htOnStateIcon, htToLeft, htToRight };
#pragma option pop

typedef Set<TRBTVHitTest, htAbove, htToRight>  TRBTVHitTests;

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCustomRBTreeView : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	bool Printing;
	int PrintWidth;
	int PrintHeight;
	bool FDefaultDrawing;
	bool EditTimerIsOn;
	TRBTVEdit* NodeEditor;
	TRBTreeNode* NodeBeingEdit;
	bool AfterGetFocus;
	int XOffset;
	int YOffset;
	bool FRightToLeft;
	TRBTVScrollBar* FHorzScrollBar;
	TRBTVScrollBar* FVertScrollBar;
	int LastLevel;
	int TreeWidth;
	int TreeHeight;
	TRBTreeNodes* FTreeNodes;
	TRBTVNodeImageSide FNodeImageSide;
	int FNodeWidth;
	int FNodeHeight;
	Graphics::TColor FNodeColor;
	Graphics::TColor FSelectedNodeColor;
	Graphics::TColor FHiddenSelectedNodeColor;
	TRBTVNodeStyle FNodeStyle;
	int FButtonSize;
	Graphics::TColor FButtonColor;
	Graphics::TColor FNodePenColor;
	TRBTreeNode* FSelectedNode;
	TRBTreeNode* FFocusedNode;
	int FHorzSpacing;
	int FVertSpacing;
	Graphics::TColor FLineColor;
	Graphics::TPenStyle FLineStyle;
	bool FShowLines;
	bool FShowRoot;
	bool FShowButtons;
	Forms::TFormBorderStyle FBorderStyle;
	bool FReadOnly;
	Controls::TImageList* FImages;
	Imglist::TChangeLink* FImagesChangeLink;
	bool FHideSelection;
	bool FDragged;
	TRBTreeNode* FDragNode;
	bool FManualNotify;
	bool FUpdatingScrollBars;
	bool FreeScrolling;
	TRBTVDrawNodeEvent FOnDrawNode;
	TRBTVEditingEvent FOnEditing;
	TRBTVEditedEvent FOnEdited;
	TRBTVNodeNotifyEvent FOnExpanded;
	TRBTVExpandingEvent FOnExpanding;
	TRBTVNodeNotifyEvent FOnCollapsed;
	TRBTVCollapsingEvent FOnCollapsing;
	TRBTVChangingEvent FOnChanging;
	TRBTVNodeNotifyEvent FOnChange;
	TRBTVNodeNotifyEvent FOnDeletion;
	TRBTVNodeNotifyEvent FOnGetImageIndex;
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall CMWantSpecialKey(Messages::TWMKey &Msg);
	void __fastcall GetImageIndex(TRBTreeNode* Node);
	void __fastcall ImagesListChange(System::TObject* Sender);
	void __fastcall SetBorderStyle(Forms::TBorderStyle Value);
	void __fastcall SetShowButtons(bool Value);
	void __fastcall SetHideSelection(bool Value);
	void __fastcall SetImages(Controls::TImageList* Value);
	void __fastcall SetShowLines(bool Value);
	void __fastcall SetReadOnly(bool Value);
	void __fastcall SetShowRoot(bool Value);
	void __fastcall SetSelected(TRBTreeNode* Value);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Message);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall WMHScroll(Messages::TWMScroll &Message);
	HIDESBASE MESSAGE void __fastcall WMVScroll(Messages::TWMScroll &Message);
	HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Message);
	HIDESBASE MESSAGE void __fastcall WMLButtonUp(Messages::TWMMouse &Message);
	HIDESBASE MESSAGE void __fastcall WMMouseMove(Messages::TWMMouse &Message);
	HIDESBASE MESSAGE void __fastcall WMLButtonDblClk(Messages::TWMMouse &Message);
	HIDESBASE MESSAGE void __fastcall WMKillFocus(Messages::TWMKillFocus &Message);
	HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &Message);
	TRBTVHitTests __fastcall InternalGetHitTestInfoAt(int X, int Y, TRBTreeNode* &HitNode);
	void __fastcall SetTreeNodes(TRBTreeNodes* Value);
	void __fastcall SetNodeImageSide(TRBTVNodeImageSide Value);
	void __fastcall SetNodeWidth(int Value);
	void __fastcall SetNodeHeight(int Value);
	void __fastcall SetNodeColor(Graphics::TColor Value);
	void __fastcall SetNodePenColor(Graphics::TColor Value);
	void __fastcall SetNodeStyle(TRBTVNodeStyle Value);
	void __fastcall SetButtonSize(int Value);
	void __fastcall SetButtonColor(Graphics::TColor Value);
	void __fastcall SetSelectedNodeColor(Graphics::TColor Value);
	void __fastcall SetHiddenSelectedNodeColor(Graphics::TColor Value);
	void __fastcall SetHorzSpacing(int Value);
	void __fastcall SetVertSpacing(int Value);
	void __fastcall SetLineColor(Graphics::TColor Value);
	void __fastcall SetLineStyle(Graphics::TPenStyle Value);
	void __fastcall SetRightToLeft(bool Value);
	void __fastcall SetDefaultDrawing(bool Value);
	void __fastcall SelectNode(TRBTreeNode* Node);
	void __fastcall FocusNode(TRBTreeNode* Node);
	void __fastcall CalcDisplayRect(void);
	void __fastcall CalcSubTreesPos(void);
	void __fastcall UpdateScrollBars(void);
	void __fastcall InternalDrawRootLine(void);
	void __fastcall HideNodeEditor(bool UpdateText);
	void __fastcall EditNode(TRBTreeNode* Node);
	
protected:
	DYNAMIC void __fastcall DoExit(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual TRBTreeNode* __fastcall CreateNode(void);
	DYNAMIC bool __fastcall CanEdit(TRBTreeNode* Node);
	DYNAMIC bool __fastcall CanChange(TRBTreeNode* Node);
	DYNAMIC bool __fastcall CanCollapse(TRBTreeNode* Node);
	DYNAMIC bool __fastcall CanExpand(TRBTreeNode* Node);
	DYNAMIC void __fastcall Change(TRBTreeNode* Node);
	DYNAMIC void __fastcall Collapse(TRBTreeNode* Node);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	DYNAMIC void __fastcall Expand(TRBTreeNode* Node);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	__property TRBTVEditingEvent OnEditing = {read=FOnEditing, write=FOnEditing};
	__property TRBTVEditedEvent OnEdited = {read=FOnEdited, write=FOnEdited};
	__property TRBTVDrawNodeEvent OnDrawNode = {read=FOnDrawNode, write=FOnDrawNode};
	__property TRBTVExpandingEvent OnExpanding = {read=FOnExpanding, write=FOnExpanding};
	__property TRBTVNodeNotifyEvent OnExpanded = {read=FOnExpanded, write=FOnExpanded};
	__property TRBTVCollapsingEvent OnCollapsing = {read=FOnCollapsing, write=FOnCollapsing};
	__property TRBTVNodeNotifyEvent OnCollapsed = {read=FOnCollapsed, write=FOnCollapsed};
	__property TRBTVChangingEvent OnChanging = {read=FOnChanging, write=FOnChanging};
	__property TRBTVNodeNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property TRBTVNodeNotifyEvent OnDeletion = {read=FOnDeletion, write=FOnDeletion};
	__property TRBTVNodeNotifyEvent OnGetImageIndex = {read=FOnGetImageIndex, write=FOnGetImageIndex};
	__property bool ShowButtons = {read=FShowButtons, write=SetShowButtons, default=1};
	__property Forms::TBorderStyle BorderStyle = {read=FBorderStyle, write=SetBorderStyle, default=1};
	__property bool ShowLines = {read=FShowLines, write=SetShowLines, default=1};
	__property bool ShowRoot = {read=FShowRoot, write=SetShowRoot, default=1};
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, default=0};
	__property bool HideSelection = {read=FHideSelection, write=SetHideSelection, default=1};
	__property Controls::TImageList* Images = {read=FImages, write=SetImages};
	__property TRBTreeNodes* Items = {read=FTreeNodes, write=SetTreeNodes};
	__property int NodeWidth = {read=FNodeWidth, write=SetNodeWidth, default=60};
	__property int NodeHeight = {read=FNodeHeight, write=SetNodeHeight, default=30};
	__property Graphics::TColor NodeColor = {read=FNodeColor, write=SetNodeColor, default=65535};
	__property Graphics::TColor NodePenColor = {read=FNodePenColor, write=SetNodePenColor, default=8421504
		};
	__property TRBTVNodeImageSide NodeImageSide = {read=FNodeImageSide, write=SetNodeImageSide, default=0
		};
	__property TRBTVNodeStyle NodeStyle = {read=FNodeStyle, write=SetNodeStyle, default=1};
	__property int ButtonSize = {read=FButtonSize, write=SetButtonSize, default=5};
	__property Graphics::TColor ButtonColor = {read=FButtonColor, write=SetButtonColor, default=16777215
		};
	__property Graphics::TColor SelectedNodeColor = {read=FSelectedNodeColor, write=SetSelectedNodeColor
		, default=255};
	__property Graphics::TColor HiddenSelectedNodeColor = {read=FHiddenSelectedNodeColor, write=SetHiddenSelectedNodeColor
		, default=-2147483633};
	__property Graphics::TPenStyle LineStyle = {read=FLineStyle, write=SetLineStyle, default=0};
	__property Graphics::TColor LineColor = {read=FLineColor, write=SetLineColor, default=16711680};
	__property int VertSpacing = {read=FVertSpacing, write=SetVertSpacing, default=20};
	__property int HorzSpacing = {read=FHorzSpacing, write=SetHorzSpacing, default=20};
	__property bool RightToLeft = {read=FRightToLeft, write=SetRightToLeft, default=0};
	__property bool DefaultDrawing = {read=FDefaultDrawing, write=SetDefaultDrawing, default=1};
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TCustomRBTreeView(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomRBTreeView(void);
	void __fastcall FullCollapse(void);
	void __fastcall FullExpand(void);
	TRBTVHitTests __fastcall GetHitTestInfoAt(int X, int Y);
	TRBTreeNode* __fastcall GetNodeAt(int X, int Y);
	void __fastcall ScrollInView(TRBTreeNode* Node);
	bool __fastcall IsEditing(void);
	void __fastcall LoadFromFile(const AnsiString FileName);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall SaveToFile(const AnsiString FileName);
	void __fastcall PrintTo(Graphics::TCanvas* PrinterCanvas, int X, int Y, int W, int H, int ANodeWidth
		, int ANodeHeight, int AHorizSpacing, int AVertSpacing, int AButtonSize, int AFontSize);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	__property TRBTreeNode* Selected = {read=FSelectedNode, write=SetSelected};
	__property Canvas ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TCustomRBTreeView(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBTVScrollBar : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TCustomRBTreeView* FControl;
	int FIncrement;
	int FPosition;
	int FRange;
	int FCalcRange;
	Forms::TScrollBarKind FKind;
	Word FMargin;
	bool FVisible;
	bool FTracking;
	__fastcall TRBTVScrollBar(TCustomRBTreeView* AControl, Forms::TScrollBarKind AKind);
	int __fastcall ControlSize(bool ControlSB, bool AssumeSB);
	int __fastcall GetScrollPos(void);
	bool __fastcall NeedsScrollBarVisible(void);
	void __fastcall ScrollMessage(Messages::TWMScroll &Msg);
	void __fastcall SetPosition(int Value);
	void __fastcall SetRange(int Value);
	void __fastcall SetVisible(bool Value);
	void __fastcall Update(bool ControlSB, bool AssumeSB);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property Forms::TScrollBarKind Kind = {read=FKind, nodefault};
	__property int ScrollPos = {read=GetScrollPos, nodefault};
	
__published:
	__property Word Margin = {read=FMargin, write=FMargin, default=0};
	__property int Increment = {read=FIncrement, write=FIncrement, default=8};
	__property int Range = {read=FRange, write=SetRange, default=0};
	__property int Position = {read=FPosition, write=SetPosition, default=0};
	__property bool Tracking = {read=FTracking, write=FTracking, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TRBTVScrollBar(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TRBTVScrollBar(void) : Classes::TPersistent() { }
	#pragma option pop
	
};

#pragma pack(pop)

typedef int HRBTreeItem;

#pragma pack(push, 1)
struct TRBNodeInfo
{
	int ImageIndex;
	void *Data;
	int IntData;
	int Count;
} ;
#pragma pack(pop)

class DELPHICLASS ERBTreeViewError;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION ERBTreeViewError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ERBTreeViewError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ERBTreeViewError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ERBTreeViewError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ERBTreeViewError(int Ident, const System::TVarRec * 
		Args, const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ERBTreeViewError(const AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ERBTreeViewError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ERBTreeViewError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ERBTreeViewError(int Ident, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ERBTreeViewError(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TRBTreeView;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TRBTreeView : public TCustomRBTreeView 
{
	typedef TCustomRBTreeView inherited;
	
__published:
	__property ShowButtons ;
	__property BorderStyle ;
	__property ShowLines ;
	__property ShowRoot ;
	__property NodeWidth ;
	__property NodeHeight ;
	__property NodeColor ;
	__property NodePenColor ;
	__property NodeImageSide ;
	__property NodeStyle ;
	__property ButtonSize ;
	__property ButtonColor ;
	__property SelectedNodeColor ;
	__property HiddenSelectedNodeColor ;
	__property LineStyle ;
	__property LineColor ;
	__property VertSpacing ;
	__property HorzSpacing ;
	__property RightToLeft ;
	__property DefaultDrawing ;
	__property ReadOnly ;
	__property HideSelection ;
	__property Items ;
	__property OnDrawNode ;
	__property OnEditing ;
	__property OnEdited ;
	__property OnExpanding ;
	__property OnExpanded ;
	__property OnCollapsing ;
	__property OnCollapsed ;
	__property OnChanging ;
	__property OnChange ;
	__property OnDeletion ;
	__property OnGetImageIndex ;
	__property Align ;
	__property Enabled ;
	__property Font ;
	__property Color ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property Ctl3D ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnStartDrag ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnDblClick ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property PopupMenu ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property ShowHint ;
	__property Images ;
	__property Anchors ;
	__property Constraints ;
	__property OnCanResize ;
	__property OnConstrainedResize ;
	__property OnDockDrop ;
	__property OnDockOver ;
	__property OnEndDock ;
	__property OnGetSiteInfo ;
	__property OnResize ;
	__property OnStartDock ;
	__property OnUnDock ;
public:
	#pragma option push -w-inl
	/* TCustomRBTreeView.Create */ inline __fastcall virtual TRBTreeView(Classes::TComponent* AOwner) : 
		TCustomRBTreeView(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomRBTreeView.Destroy */ inline __fastcall virtual ~TRBTreeView(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRBTreeView(HWND ParentWindow) : TCustomRBTreeView(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Rbtreeview */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rbtreeview;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RBTreeView
